// -*-c++-*-
//===========================================================
//=     University of Illinois at Urbana/Champaign          =
//=     Department of Computer Science                      =
//=     Dr. Dan Roth - Cognitive Computation Group          =
//=                                                         =
//=  Project: Snow                                          =
//=                                                         =
//=   Module: NaiveBayes.h                                  =
//=  Version: 2.1                                           =
//=  Authors: Jeff Rosen and Andrew Carlson                 =
//=     Date: xx/xx/99                                      = 
//=                                                         =
//= Comments:                                               =
//===========================================================

#ifndef __NAIVEBAYES_H__
#define __NAIVEBAYES_H__

#include "LearningAlgorithm.h"

class NaiveBayes : public LearningAlgorithm
{
public:
    NaiveBayes();

    bool PresentExample( Target& tar, Example& ex );
    void TrainingComplete( Target& tar );

    void PrepareToRank();
    void SetTargetActivation( Target& tar, Example& ex );
    double ReturnNormalizedActivation( Target& tar);
    
    void ClearTotalPrior();

    void Show( ostream& out );
    
    void Read( ifstream& in );
    void Write( ofstream& out );

private:
	double totalPrior;
};

inline NaiveBayes::NaiveBayes() :
        LearningAlgorithm()
{
}

inline void NaiveBayes::PrepareToRank()
{
    //threshold = 0.0;
}

inline void NaiveBayes::ClearTotalPrior()
{
	totalPrior = 0.0;
}

#endif
